

    .text  ; Tell compiler that the following is code



; puts
;
;
;
;  |--------------------------|
;  | String to print          | <- BP+8
;  |--------------------------|
;  | Return address           | <- BP+4
;  |--------------------------|
;  | BP                       | <- BP
;  |--------------------------|
;
    global puts
puts:
    ; 1. write the prologue.

    ; 2. MOV the string address from the stack into ESI

puts_loop:
    ; 3. loop: MOV one character from ESI into AL
    ; 4. CMP the character to 0. If zero, JMP to puts_done
    ; 5. If not zero, push the character onto the stack and CALL putc
    ; 6. Clean up the stack after returning from the call.
    ; 7. JMP back to puts_loop

puts_done:
    ; 8. Write the epilogue and return.

; putc
;
; Prints one character to the terminal. Pass the character to print on the stack.
;
;  |--------------------------|
;  | Char to print            | <- BP+8
;  |--------------------------|
;  | Return address           | <- BP+4
;  |--------------------------|
;  | BP                       | <- BP
;  |--------------------------|
;
    global putc
putc:
    push ebp               ; Prologue
    mov ebp,esp
    pusha

    mov ebx,[y_pos]
    mov eax,80
    mul ebx                ; EAX <- y_pos * 80

    add eax,[x_pos]        ; EAX <- y_pos * 80 + x_pos
    shl eax,1              ; Multiply offset by 2 (size of each character)

    mov esi,0xb8000        ; Get base of screen buffer in ESI

    mov cl,[ebp+8]         ; Get character to print from the stack
    and ecx,0xff
    or cx,0x700
    mov [esi+eax],cx
    inc word [x_pos]


    popa                   ; Epilogue
    pop ebp
    ret


    .bss ; Tell the compiler that the following is data

x_pos:
    dw 0
y_pos:
    dw 0
